import { Component, Inject, OnInit } from "@angular/core";
import { Validators, FormBuilder, FormGroup, FormControl } from "@angular/forms";
import { TodoService } from "../services/todo-service";
import ITodo from "../../../shared/todo-dto";

import { Http } from "@angular/http";

@Component({
  selector: "todo-cmp",
  templateUrl: "app/todo/templates/todo.html",
  styleUrls: ["app/todo/styles/todo.css"]
})
export class TodoCmp implements OnInit {
  title = "ng2do";
  todos: ITodo[] = [];
  todoForm: ITodo;

  constructor(private todoService: TodoService, private http: Http) {
    this.todoForm = {
      "todoMessage": ""
    };
  }

  ngOnInit() {
	  this.getAll();
  }

  private getAll():void {
    this.todoService
        .getAll()
        .subscribe((todos) => {
          this.todos = todos;
        });
  }

  add(message:string):void {
    this.todoService
        .add(message)
        .subscribe((m) => {
          this.todos.push(m);
          this.todoForm.todoMessage = "";
        });
  }

  remove(id:string):void {
    this.todoService
      .remove(id)
      .subscribe(() => {
        this.todos.forEach((t, i) => {
          if (t._id === id)
            this.todos.splice(i, 1);
        });
      });
  }
}
